;; ##################################################################################
;; # ============================================================================== #
;; # MrEd Designer - default-values.ss                                              #
;; # http://mreddesigner.lozi.org                                                   #
;; # Copyright (C) Lozi Jean-Pierre, 2004 - mailto:jean-pierre@lozi.org             #
;; # ============================================================================== #
;; #                                                                                #
;; # This program is free software; you can redistribute it and/or                  #
;; # modify it under the terms of the GNU General Public License                    #
;; # as published by the Free Software Foundation; either version 2                 #
;; # of the License, or (at your option) any later version.                         #
;; #                                                                                #
;; # This program is distributed in the hope that it will be useful,                #
;; # but WITHOUT ANY WARRANTY; without even the implied warranty of                 #
;; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  #
;; # GNU General Public License for more details.                                   #
;; #                                                                                #
;; # You should have received a copy of the GNU General Public License              #
;; # along with this program; if not, write to the Free Software                    #
;; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    #
;; #                                                                                #
;; ##################################################################################

;;========================================================
;; * frame
;;========================================================
(define frame-default-values '(frame (necessary)
                                     (label "Untitled Frame")
                                     (optional)
                                     (parent #f)
                                     (width 400)
                                     (height 300)
                                     (x 400)
                                     (y 10)
                                     (style '())
                                     (enabled #t)
                                     (border 0)
                                     (spacing 0)
                                     (alignment '(center top))
                                     (min-width 0)
                                     (min-height 0)
                                     (stretchable-width #t)
                                     (stretchable-height #t)))

;;========================================================
;; * button
;;========================================================
(define button-default-values `(button (necessary)
                                       (label "Button")
                                       (parent #f)
                                       (callback (lambda (button control-event) (void)))
                                       (optional)
                                       (style '())
                                       (enabled #t)
                                       (vert-margin 2)
                                       (horiz-margin 2)
                                       (min-width 0)
                                       (min-height 0)
                                       (stretchable-width #f)
                                       (stretchable-height #f)))

;;========================================================
;; * radio-box
;;========================================================
(define radio-box-default-values '(radio-box (necessary)
                                             (label "Radio Box")
                                             (choices '("First element" "Second element"))
                                             (parent #f)
                                             (callback (lambda (radio-box control-event) (void)))
                                             (optional)
                                             (style '(vertical))
                                             (selection 1)
                                             (enabled #t)
                                             (vert-margin 0)
                                             (horiz-margin 0)
                                             (min-width 0)
                                             (min-height 0)
                                             (stretchable-width #f)
                                             (stretchable-height #f)))
  
;;========================================================
;; * check-box
;;========================================================
(define check-box-default-values '(check-box (necessary)
                                             (label "Check Box")
                                             (parent #f)
                                             (callback (lambda (check-box control-event) (void)))
                                             (optional)
                                             (style '())
                                             (enabled #t)
                                             (vert-margin 2)
                                             (horiz-margin 2)
                                             (min-width 0)
                                             (min-height 0)
                                             (stretchable-width #f)
                                             (stretchable-height #f)))

;;========================================================
;; * pane
;;========================================================
(define pane-default-values '(pane (necessary)
                                   (parent #f)
                                   (optional)
                                   (vert-margin 0)
                                   (horiz-margin 0)
                                   (border 0)
                                   (spacing 0)
                                   (alignment '(left center))
                                   (min-width 0)
                                   (min-height 0)
                                   (stretchable-width #t)
                                   (stretchable-height #t)))

;;========================================================
;; * horizontal-pane
;;========================================================
(define horizontal-pane-default-values '(horizontal-pane (necessary)
                                                         (parent #f)
                                                         (optional)
                                                         (vert-margin 0)
                                                         (horiz-margin 0)
                                                         (border 0)
                                                         (spacing 0)
                                                         (alignment '(left center))
                                                         (min-width 0)
                                                         (min-height 0)
                                                         (stretchable-width #t)
                                                         (stretchable-height #t)))

;;========================================================
;; * vertical-pane
;;========================================================
(define vertical-pane-default-values '(vertical-pane (necessary)
                                                     (parent #f)
                                                     (optional)
                                                     (vert-margin 0)
                                                     (horiz-margin 0)
                                                     (border 0)
                                                     (spacing 0)
                                                     (alignment '(left center))
                                                     (min-width 0)
                                                     (min-height 0)
                                                     (stretchable-width #t)
                                                     (stretchable-height #t)))

;;========================================================
;; * panel
;;========================================================
(define panel-default-values '(panel (necessary)
                                     (parent #f)
                                     (optional)
                                     (style '())
                                     (enabled #t)
                                     (vert-margin 0)
                                     (horiz-margin 0)
                                     (border 0)
                                     (spacing 0)
                                     (alignment '(left center))
                                     (min-width 0)
                                     (min-height 0)
                                     (stretchable-width #t)
                                     (stretchable-height #t)))

;;========================================================
;; * horizontal-panel
;;========================================================
(define horizontal-panel-default-values '(horizontal-panel (necessary)
                                                           (parent #f)
                                                           (optional)
                                                           (style '())
                                                           (enabled #t)
                                                           (vert-margin 0)
                                                           (horiz-margin 0)
                                                           (border 0)
                                                           (spacing 0)
                                                           (alignment '(left center))
                                                           (min-width 0)
                                                           (min-height 0)
                                                           (stretchable-width #t)
                                                           (stretchable-height #t)))

;;========================================================
;; * vertical-panel
;;========================================================
(define vertical-panel-default-values '(vertical-panel (necessary)
                                                       (parent #f)
                                                       (optional)
                                                       (style '())
                                                       (enabled #t)
                                                       (vert-margin 0)
                                                       (horiz-margin 0)
                                                       (border 0)
                                                       (spacing 0)
                                                       (alignment '(left center))
                                                       (min-width 0)
                                                       (min-height 0)
                                                       (stretchable-width #t)
                                                       (stretchable-height #t)))

;;========================================================
;; * tab-panel
;;========================================================
(define tab-panel-default-values '(tab-panel (necessary)
                                             (choices '("First choice" "Second choice"))
                                             (parent #f)
                                             (callback (lambda (tab-panel control-event) (void)))
                                             (optional)
                                             (style '())
                                             (enabled #t)
                                             (vert-margin 0)
                                             (horiz-margin 0)
                                             (border 0)
                                             (spacing 0)
                                             (alignment '(center top))
                                             (min-width 0)
                                             (min-height 0)
                                             (stretchable-width #t)
                                             (stretchable-height #t)))

;;========================================================
;; * group-box-panel
;;========================================================
(define group-box-panel-default-values '(group-box-panel (necessary)
                                                         (label "Group Box Panel")
                                                         (parent #f)
                                                         (optional)
                                                         (style '())
                                                         (enabled #t)
                                                         (vert-margin 2)
                                                         (horiz-margin 2)
                                                         (border 0)
                                                         (spacing 0)
                                                         (alignment '(center top))
                                                         (min-width 0)
                                                         (min-height 0)
                                                         (stretchable-width #t)
                                                         (stretchable-height #t)))

;;========================================================
;; * grow-box-spacer-pane
;;========================================================
(define grow-box-spacer-pane-default-values '(grow-box-spacer-pane (necessary)
                                                                   (parent #f)
                                                                   (optional)
                                                                   (vert-margin 0)
                                                                   (horiz-margin 0)
                                                                   (border 0)
                                                                   (spacing 0)
                                                                   (alignment '(center center))
                                                                   (min-width 0)
                                                                   (min-height 0)
                                                                   (stretchable-width #t)
                                                                   (stretchable-height #t)))

;;========================================================
;; * message
;;========================================================
(define message-default-values '(message (necessary)
                                         (label "Message")
                                         (parent #f)
                                         (optional)
                                         (style '())
                                         (enabled #t)
                                         (vert-margin 2)
                                         (horiz-margin 2)
                                         (min-width 0)
                                         (min-height 0)
                                         (stretchable-width #f)
                                         (stretchable-height #f)))

;;========================================================
;; * slider
;;========================================================
(define slider-default-values '(slider (necessary)
                                       (label "Slider")
                                       (min-value 0)
                                       (max-value 100)
                                       (parent #f) 
                                       (callback (lambda (slider control-event) (void)))
                                       (optional)
                                       (init-value 0)
                                       (style '(horizontal)) 
                                       (enabled #t)
                                       (vert-margin 2)
                                       (horiz-margin 2)
                                       (min-width 0)
                                       (min-height 0) 
                                       (stretchable-width #t)
                                       (stretchable-height #f)))

;;========================================================
;; * gauge
;;========================================================
(define gauge-default-values '(gauge (necessary)
                                     (label "Gauge")
                                     (range 100)
                                     (parent #f)
                                     (optional)
                                     (style '(horizontal))
                                     (enabled #t)
                                     (vert-margin 0)
                                     (horiz-margin 0)
                                     (min-width 0)
                                     (min-height 0)
                                     (stretchable-width #t)
                                     (stretchable-height #f)))

;;========================================================
;; * list-box
;;========================================================
(define list-box-default-values '(list-box (necessary)
                                           (label "List Box")
                                           (choices '("First element" "Second element"))
                                           (parent #f)
                                           (callback (lambda (list-box control-event) (void)))
                                           (optional)
                                           (style '(single))
                                           (selection #f)
                                           (enabled #t)
                                           (vert-margin 0)
                                           (horiz-margin 0)
                                           (min-width 0)
                                           (min-height 0)
                                           (stretchable-width #t)
                                           (stretchable-height #t)))

;;========================================================
;; * choice
;;========================================================
(define choice-default-values '(choice (necessary)
                                       (label "Choice")
                                       (choices '("First element" "Second element"))
                                       (parent #f)
                                       (callback (lambda (button control-event) (void)))
                                       (optional)
                                       (style '())
                                       (selection 1)
                                       (enabled #t)
                                       (vert-margin 0)
                                       (horiz-margin 0)
                                       (min-width 0)
                                       (min-height 0)
                                       (stretchable-width #f)
                                       (stretchable-height #f)))

;;========================================================
;; * text-field
;;========================================================
(define text-field-default-values '(text-field (necessary)
                                               (label "Text Field")
                                               (parent #f)
                                               (callback (lambda (text-field control-event) (void)))
                                               (optional)
                                               (init-value "Text")
                                               (style '(single))
                                               (enabled #t)
                                               (vert-margin 2)
                                               (horiz-margin 2)
                                               (min-width 0)
                                               (min-height 0)
                                               (stretchable-width #t)
                                               (stretchable-height #f)))

;;========================================================
;; * canvas
;;========================================================
(define canvas-default-values '(canvas (necessary)
                                       (parent #f)
                                       (style '(border))
                                       (optional)
                                       (paint-callback (lambda (canvas control-event) (void)))
                                       (label "Canvas")
                                       (enabled #t)
                                       (vert-margin 0)
                                       (horiz-margin 0)
                                       (min-width 0)
                                       (min-height 0)
                                       (stretchable-width #t)
                                       (stretchable-height #t)))
