;; ##################################################################################
;; # ============================================================================== #
;; # MrEd Designer - properties-frame.ss                                            #
;; # http://mreddesigner.lozi.org                                                   #
;; # Copyright (C) Lozi Jean-Pierre, 2004 - mailto:jean-pierre@lozi.org             #
;; # ============================================================================== #
;; #                                                                                #
;; # This program is free software; you can redistribute it and/or                  #
;; # modify it under the terms of the GNU General Public License                    #
;; # as published by the Free Software Foundation; either version 2                 #
;; # of the License, or (at your option) any later version.                         #
;; #                                                                                #
;; # This program is distributed in the hope that it will be useful,                #
;; # but WITHOUT ANY WARRANTY; without even the implied warranty of                 #
;; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  #
;; # GNU General Public License for more details.                                   #
;; #                                                                                #
;; # You should have received a copy of the GNU General Public License              #
;; # along with this program; if not, write to the Free Software                    #
;; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    #
;; #                                                                                #
;; ##################################################################################

;; We need the screen width and height to set the windows positions.
(define-values (screen-w screen-h) (get-display-size))

;; We need to derive the frame class to override the on-close method.
(define properties-frame%
  (class frame%
    ;; We override on-close...
    (override on-close)
    ;; When on-close is called, we exit the project.
    (define (on-close) (send properties-frame-windows-properties-frame-menu-item check #f))
    (super-instantiate ())))

;; Let's define the properties frame itself
(define properties-frame (new properties-frame% 
                   (label "Properties")
                   (parent toolbox-frame)
                   (x (- screen-w 370))
                   (y 5)
                   (height 288)
                   (width 365)))

;; The main vertical pane
(define properties-vertical-pane (new vertical-panel%
                                     (border 0)
                                     (parent properties-frame)))

;; The main widget's horizonal pane
(define properties-sub-horizontal-panel (new horizontal-panel%
                                                      (border 0)
                                                      (parent properties-vertical-pane)))

;; The main widget
(define properties-widget (new properties-widget% (parent properties-sub-horizontal-panel)))

;; The button's horizontal panel
(define properties-horizontal-panel (new horizontal-panel%
                                       (parent properties-vertical-pane)
                                       (stretchable-height #f)
                                       (alignment '(center bottom))))

;; The 'Edit Value...' button
(define properties-edit-button (new button% 
                                      (label (make-object bitmap% (build-path "images" "properties-edit-value.png") 'png (make-object color% 255 255 255)))
                                      (callback (lambda (button control-event)
                                                  (send properties-widget edit-current-value-with-dialog)))
                                      (min-width 110)
                                      (enabled #f)
                                      (parent properties-horizontal-panel)))

;; The 'Reset Value...' button
(define properties-rvalue-button (new button% 
                                    (label (make-object bitmap% (build-path "images" "properties-rvalue.png") 'png (make-object color% 255 255 255)))
                                    (callback (lambda (button control-event)
                                                (send properties-widget reset-current-value)))
                                    (min-width 110)
                                    (enabled #f)
                                    (parent properties-horizontal-panel)))

;; The 'Reset Widget' button
(define properties-rwidget-button (new button% 
                                    (label (make-object bitmap% (build-path "images" "properties-rwidget.png") 'png (make-object color% 255 255 255)))
                                    (callback (lambda (button control-event)
                                                (send properties-widget reset-widget)))
                                    (min-width 110)
                                    (enabled #f)
                                    (parent properties-horizontal-panel)))

;; To fix a bug under OS X
;; Might exist a better way to fix it
(send properties-widget on-size (send properties-frame get-width) (send properties-frame get-height))

;; We show the properties frame...
(send properties-frame show #t)